<?xml version="1.0" encoding="utf-8" ?>
<doctrine-mapping
        xmlns="http://doctrine-project.org/schemas/orm/doctrine-mapping"
        xmlns:gedmo="http://gediminasm.org/schemas/orm/doctrine-extensions-mapping"
        xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
        xsi:schemaLocation="http://doctrine-project.org/schemas/orm/doctrine-mapping
                            https://raw.github.com/doctrine/doctrine2/master/doctrine-mapping.xsd">

    <entity name="App\Domain\Registry\Model\Mesurement" table="registry_mesurement">

        <id name="id" column="id" type="uuid"/>

        <field name="name" column="name"/>
        <field name="type" column="type" nullable="true"/>
        <field name="description" column="description" type="text" nullable="true"/>
        <field name="cost" column="cost" nullable="true"/>
        <field name="charge" column="charge" nullable="true"/>
        <field name="status" column="status" nullable="true"/>
        <field name="planificationDate" column="planification_date" type="date" nullable="true"/>
        <field name="comment" column="comment" nullable="true"/>

        <many-to-many field="proofs" target-entity="App\Domain\Registry\Model\Proof" mapped-by="mesurements">
            <order-by>
                <order-by-field name="name"/>
            </order-by>
        </many-to-many>
        <many-to-one field="clonedFrom" target-entity="App\Domain\Registry\Model\Mesurement"/>

        <!-- Traits -->
        <many-to-one field="collectivity" target-entity="App\Domain\User\Model\Collectivity"/>
        <many-to-one field="creator" target-entity="App\Domain\User\Model\User"/>
        <field name="createdAt" column="created_at" type="datetime_immutable">
            <gedmo:timestampable on="create"/>
        </field>
        <field name="updatedAt" column="updated_at" type="datetime_immutable">
            <gedmo:timestampable on="update"/>
        </field>

    </entity>

</doctrine-mapping>
